const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const transportePage = require('../../../page-objects/parametrizacao/pedidos/tipoDeTransporte.po.js');
const j = require('../../../json/leitorJson.po');

const transporteGridId = '1055028969445003946601';

describe('Tela Tipo de Transporte', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        transportePage.abrir();
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Deve acessar a tela Tipo de Transporte', () => {
        expect(z.component.header.getTitle()).toBe('Tipo de Transporte');
    });

    it('Deve adicionar Tipo de Transporte', () => {
        transportePage.adicionarTransporte(j.getValor('codigo1'), j.getValor('nomeTransporte1'));
        geralPage.clickSalvar();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(transporteGridId, j.getValor('codigo1')))
            .toMatch(j.getValor('codigo1'));
    });

    it('Deve editar Tipo de Transporte', () => {
        geralPage.filterIt(j.getValor('codigo1'));
        geralPage.esperarLoading();
        geralPage.clickGrid('NMTIPTRANS', j.getValor('nomeTransporte1'), transporteGridId);
        geralPage.clickEditar();
        transportePage.editarTransporte(j.getValor('nomeTransporte'));
        geralPage.clickSalvar();
        geralPage.clickVoltar();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(transporteGridId, j.getValor('nomeTransporte'), 1, false))
            .toMatch(j.getValor('nomeTransporte'));
    });

    it('Excluir Cadastro', () => {
        geralPage.filterIt(j.getValor('codigo1'));
        geralPage.esperarLoading();
        geralPage.clickGrid('CDTIPTRANS', j.getValor('codigo1'), transporteGridId);
        transportePage.apagarTransporte();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(transporteGridId, j.getValor('codigo1')))
            .not.toMatch(j.getValor('codigo1'));
    });
});
